#!/bin/bash

TEST_PATH=/var/log/stress-test
REBOOT_START=${TEST_PATH}/reboot_start
REBOOT_DELAY=10   # DELAY SECONDS: 10 * 2
case $1 in
start)
	echo $(date +%s) > ${REBOOT_START}
	echo "[Reboot] $(date): Start $2h ..."
	;;
*)
	if [ ! -f ${REBOOT_START} ]; then
		rm -rf /usr/local/bin/toybrick-custom.sh
		echo "[Reboot] $(date): Force to quit reboot test ..."
		exit 1
	fi

	start_secs=$(cat ${REBOOT_START})
	now_secs=$(date +%s)
	secs=$(expr ${now_secs} - ${start_secs})
	if [ ${secs} -ge $1 ]; then
		sleep 20
		rm -rf ${REBOOT_START} /usr/local/bin/toybrick-custom.sh
		echo "[Reboot] $(date): SUCCESS ..."
		exit 0
	else
		h=$(expr ${secs} / 3600)
		r=$(expr ${secs} % 3600)
		m=$(expr ${r} / 60)
		s=$(expr ${r} % 60)
		echo "[Reboot] $(date): $h:$m:$s passed ..."
		for i in $(seq ${REBOOT_DELAY})
		do
			echo "[Reboot] $(date):Reboot after $(expr $(expr ${REBOOT_DELAY} - $i) \* 2)s ..." > /dev/ttyFIQ0
			sleep 2
		done
		echo "[Reboot] $(date): $h:$m:$s ..." > /dev/ttyFIQ0
	fi
	;;
esac
sync
reboot
